﻿using UnityEngine;
using System.Collections;

public class FaceUpdate : MonoBehaviour
{
	public AnimationClip[] animations;

	Animator anim;

	public float delayWeight;

	public int buttonWidth=140;
	public int buttonHeight=50;
	public int margin = 10;


	void Start ()
	{
		anim = GetComponent<Animator> ();
	}

	void OnGUI ()
	{
		int cnt=0;
		foreach (var animation in animations) {
			//if (GUILayout.Button (animation.name)) {
			if (GUI.Button(new Rect(margin, (buttonHeight + margin) * cnt, buttonWidth, buttonHeight), animation.name))
			{
				anim.CrossFade (animation.name, 0);
			}
			++cnt;
		}
	}

	float current = 0;


	void Update ()
	{

		if (Input.GetMouseButton (0)) {
			current = 1;
		} else {
			current = Mathf.Lerp (current, 0, delayWeight);
		}
		anim.SetLayerWeight (1, current);
	}
}
