﻿using UnityEngine;
using System.Collections;

//狩りゲーム風カメラ


public class KarigeCamera : MonoBehaviour
{

	public GameObject playerObject;

	public float cameraDistance = 3.21f;
	public float cameraDistanceMin = 1.0f;
	public float cameraDistanceMax = 4.0f;


	public float cameraHeight=1.15f;
	float cameraMovement = 90.0f;
	public float cameraRotationY=15.0f;
	
	public float cameraPitch = 0.0f;
	public float cameraPitchMin = -16.0f;
	public float cameraPitchMax = 20.0f;

	float cameraZoomSpeed = 2.0f;


	// Use this for initialization
	void Start () {

		//Get Unity-chan 
		playerObject = GameObject.Find("unitychan");
	}
	
	// Update is called once per frame
	void Update () {

		float deadZone = 0.25f;

#if UNITY_PSM
		// camera up/down
		if (Input.GetAxis("R_Stick_Vertical") > deadZone || Input.GetAxis("R_Stick_Vertical") < -deadZone)
		{
			cameraPitch = cameraPitch - Input.GetAxis("R_Stick_Vertical") * cameraMovement * Time.deltaTime;
		}

		cameraPitch = Mathf.Clamp(cameraPitch, cameraPitchMin, cameraPitchMax);


		// camera right/left
		if (Input.GetKey(KeyCode.Q))
		{
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y + cameraMovement * Time.deltaTime, 0);
		}
		else if (Input.GetKey(KeyCode.E))
		{
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y - cameraMovement * Time.deltaTime, 0);
		}


		// camera right/left
		if (Input.GetAxis("R_Stick_Horizontal") > deadZone || Input.GetAxis("R_Stick_Horizontal") < -deadZone)
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y + Input.GetAxis("R_Stick_Horizontal") * cameraMovement * Time.deltaTime, 0);
		else
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y, 0);
#else
		// camera up/down
		if (Input.GetKey(KeyCode.UpArrow))
		{
			cameraPitch = cameraPitch - cameraMovement *Time.deltaTime;
		}
		else if (Input.GetKey(KeyCode.DownArrow))
		{
			cameraPitch = cameraPitch + cameraMovement * Time.deltaTime;
		}

		cameraPitch = Mathf.Clamp(cameraPitch, cameraPitchMin, cameraPitchMax);

		
		// camera right/left
		if (Input.GetKey(KeyCode.Q))
		{
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y + cameraMovement * Time.deltaTime, 0);
		}
		else if (Input.GetKey(KeyCode.E))
		{
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y - cameraMovement * Time.deltaTime, 0);
		}
		else
			transform.localEulerAngles = new Vector3(cameraPitch, transform.localEulerAngles.y, 0);
#endif


		//Zoom
		if (Input.GetKey(KeyCode.JoystickButton4) || Input.GetKey(KeyCode.Alpha1))
			cameraDistance -= cameraZoomSpeed*Time.deltaTime;
		else if (Input.GetKey(KeyCode.JoystickButton5) || Input.GetKey(KeyCode.Alpha2))
			cameraDistance += cameraZoomSpeed*Time.deltaTime;

		cameraDistance = Mathf.Clamp(cameraDistance, cameraDistanceMin, cameraDistanceMax);

		transform.position = playerObject.transform.position;
		transform.position += transform.rotation * Vector3.back * cameraDistance;
		transform.position += Vector3.up * cameraHeight;

	}



}
